#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>


#include "win2tif.h"
#include "xgofbdec.h"

// Je ne sais pas si c'est un bug de QuickTime ou une mauvaise utilisation
// mais le programme suivant, driv de BOOL XGOQTBITMAP::GetBoundRect de xgobmp.c
// dvore de la mmoire (pres de 100 Mo avec la boucle)
// mettre ici le chemin d'un fichier QuickTime valide
    
#define FMTSTD "TIF"
#define DIBHandle HGLOBAL

/*
FlushDibInBitmap : Write a DIB in a format of bitmap file, in memory
  lpDib : pointer to Bitmap Header (BITMAPINFO and BITMAPINFOHEADER)
  lpRawData : point to Bitmap raw data (just after Header in lpRawData is NULL)

  lpPtr : pointer where writting data
  dwSize : size of Buffer lpPtr
  
  pResizeFlushPtrFunc : pointer to function to realloc memory of lpPtr buffer 
       is full
  lpCustomDataForResize : custom parameter gived to the pResizeFlushPtrFunc func
  lplpNewPtr : will contain the final pointer to the buffer that contain bitmap file.

  if you are sure the buffer size (in dwSize) is bigger than the bitmap that will be
    created, pResizeFlushPtrFunc, lpCustomDataForResize and lplpNewPtr can be NULL

  if pResizeFlushPtrFunc is not NULL, lpPtr can be NULL and dwSize = 0
  Return value : size of the Bitmap file (or 0 if error)

FLUSHDIBAPIEXPORT DWORD FLUSHDIBAPI FlushDibInBitmap(LPVOID lpDib,LPVOID lpRawData,
                        TYPEFORMATOUT tFormatOut, long lQuality,
                        LPVOID lpPtr,DWORD dwSize,
                        TResizeFlushPtrFunc pResizeFlushPtrFunc=NULL,
                        LPVOID lpCustomDataForResize=NULL,
                        LPVOID* lplpNewPtr=NULL);
*/

LPVOID CALLBACK AllocResize(LPVOID lpOldPtr, LPVOID lpCustomDataForResize,
                            DWORD dwNewSize)
{
    LPVOID lpRet ;
    if ((lpOldPtr==NULL) && (dwNewSize>0))
        lpRet = malloc(dwNewSize);
    else
    if ((lpOldPtr!=NULL) && (dwNewSize>0))
        lpRet = realloc(lpOldPtr,dwNewSize);
    else
    if ((lpOldPtr!=NULL) && (dwNewSize==0))
    {
        free(lpOldPtr);
        lpRet=NULL;
    }
    return lpRet;
}
/*
LPXGOFREEBITMAPDECODER GetDecoderForFile(LPCSTR szFileName)
{
    HANDLE hf;
    char szBuffer[0x200];
    LPXGOFREEBITMAPDECODER lpDecoderRet = NULL;

    hf = CreateFile(szFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,
                 FILE_FLAG_SEQUENTIAL_SCAN,NULL);
    if (hf!=NULL)
      {
        DWORD dwSizeRead=0;
        if (ReadFile(hf,szBuffer,sizeof(szBuffer)-1,&dwSizeRead,NULL))
           lpDecoderRet = FindDecoderForFileInMemory(szBuffer, dwSizeRead);
        CloseHandle(hf);
      };
    return lpDecoderRet;
}*/

DIBHandle LoadDIBFromNoQT(LPCSTR lpszFileName)
{
    DIBHandle dibHandle=NULL;
    //LPXGOFREEBITMAPDECODER lpDecoder = GetDecoderForFile(lpszFileName);
    //if (lpDecoder!=NULL)
    {
        dibHandle = (DIBHandle)LoadInDIBFromFile(/*lpDecoder,*/(LPSTR)lpszFileName);
        //DeleteDecoder(lpDecoder);
    }

    // test JPG problem
    
    if (dibHandle!=NULL)
      {
          BOOL fRet=FALSE;
          RECT rcBound;
          fRet =  GetBitmapFileInformationFromFile((LPSTR)lpszFileName,
                                       &rcBound,NULL,NULL);
          printf("Size of %s : %u*%u\t",lpszFileName,rcBound.right,rcBound.bottom);
      }
    
    return dibHandle;
}

BOOL ConvertPic(LPCSTR lpPicFileName,LPCSTR lpszCnvFileName,
                TYPEFORMATOUT tFormatOut, long lQuality)
{
    BOOL fRet=FALSE;
    DIBHandle dibHandle=NULL;
    dibHandle=LoadDIBFromNoQT(lpPicFileName);


    if (dibHandle!=NULL)
    {
        LPVOID lpData=NULL;
        LPVOID lpDib=GlobalLock(dibHandle);
        DWORD dwSize=FlushDibInBitmap(lpDib,NULL,
                            tFormatOut,lQuality,
                            NULL,0,
                            &AllocResize,NULL,&lpData);
        if (dwSize>0)
        {
            HANDLE hFile;
            hFile=CreateFile(lpszCnvFileName, GENERIC_WRITE ,0,NULL, CREATE_ALWAYS,
                             FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
            if (hFile!=NULL)
            {
                DWORD dwSizeWritten=0;
                if (!WriteFile(hFile,lpData,dwSize,&dwSizeWritten,NULL))
                    fRet=FALSE;
                else
                    fRet=dwSizeWritten==dwSize;
                if (!CloseHandle(hFile))
                    fRet=TRUE;                
            }
            AllocResize(lpData,NULL,0); // freeing
        }

        GlobalUnlock(dibHandle);
        GlobalFree(dibHandle);
    }
    return fRet;
}

TYPEFORMATOUT GetFormatFromString(LPCSTR lpszBitmapFormat,LPSTR lpExt)
{
    TYPEFORMATOUT tFormatOut=FORMAT_BITMAP_INVALID;
	if (((*lpszBitmapFormat)=='B') || ((*lpszBitmapFormat)=='b'))
    {
		tFormatOut=FORMAT_BITMAP_BMP;
        lstrcpy(lpExt,"bmp");
    }
	if (((*lpszBitmapFormat)=='J') || ((*lpszBitmapFormat)=='j'))
    {
		tFormatOut=FORMAT_BITMAP_JPEG;
        lstrcpy(lpExt,"jpg");
    }

	if (((*lpszBitmapFormat)=='P') || ((*lpszBitmapFormat)=='p'))
    {
		tFormatOut=FORMAT_BITMAP_PNG;
        lstrcpy(lpExt,"png");
    }

	if (((*lpszBitmapFormat)=='T') || ((*lpszBitmapFormat)=='t'))
    {
		tFormatOut=FORMAT_BITMAP_TIFF;
        lstrcpy(lpExt,"tif");
    }

	if (strcmpi(lpszBitmapFormat,"PCX")==0)
    {
		tFormatOut=FORMAT_BITMAP_PCX;
        lstrcpy(lpExt,"pcx");
    }

	if (((*lpszBitmapFormat)=='G') || ((*lpszBitmapFormat)=='g'))
    {
		tFormatOut=FORMAT_BITMAP_GIF256;
        lstrcpy(lpExt,"gif");
    }
    /*
	if (((*lpszBitmapFormat)=='E') || ((*lpszBitmapFormat)=='e'))
    {
		tFormatOut=FORMAT_BITMAP_EMF;
        lstrcpy(lpExt,"emf");
    }

	if (((*lpszBitmapFormat)=='W') || ((*lpszBitmapFormat)=='w'))
    {
		tFormatOut=FORMAT_BITMAP_WMF;
        lstrcpy(lpExt,"wmf");
    }*/

    return tFormatOut;
}


BOOL DoConvertOnePicture(LPCSTR lpPicFileName,LPCSTR lpszFormatName,long lQuality,BOOL fVerbose)
{
    char szCnvFileName[MAX_PATH+256];
    char szExt[16]="";
    BOOL fRet=TRUE;

    TYPEFORMATOUT tFormatOut=GetFormatFromString(lpszFormatName,szExt);
    if (tFormatOut==FORMAT_BITMAP_INVALID)
    {
        if (fVerbose)
            printf("Invalid format name !\n");
        fRet=FALSE;
    }

    if (fRet)
    {
        lstrcpy(szCnvFileName,lpPicFileName);
        LPSTR lpParcCnvFileName=szCnvFileName;
        LPSTR lpLastDotPosition=szCnvFileName + lstrlen(szCnvFileName);
        while ((*lpParcCnvFileName)!='\0')
        {
            if ((*lpParcCnvFileName)=='.')
                lpLastDotPosition=lpParcCnvFileName;
            lpParcCnvFileName = CharNext(lpParcCnvFileName);
        }
        wsprintf(lpLastDotPosition,".%s",szExt);
    }

    if (fRet)
    {
        if (fVerbose)
            printf("convert %s to %s , Quality=%d: ",lpPicFileName,szCnvFileName,lQuality);
        fRet = ConvertPic(lpPicFileName,szCnvFileName,tFormatOut,lQuality);
        if (fVerbose)
            printf("%s\n",fRet ? "TRUE":"FALSE");
    }
    return fRet;
}

LPSTR GetLatestChar(LPSTR lpText)
{
    LPSTR lpNext,lpNextNext,lpRet;
    lpRet = NULL;
    lpNext = lpText;

    if (lpText==NULL)
        return NULL;

    for (;;)
    {
        lpNextNext = CharNext(lpNext);
        if (lpNextNext == lpNext)
            return lpRet;
        else
        {
            lpRet = lpNext;
            lpNext = lpNextNext;
        }
    }
}

LPCSTR GetNameWithoutPath(LPCSTR lpFn)
{
LPCSTR lpRet = lpFn ;
LPCSTR lpNext ;
  while ((*lpFn) != '\0')
    {
      if (((*lpFn) == ':') || ((*lpFn) == '\\')) lpRet = lpFn + 1;
      lpNext=CharNext(lpFn);
      lpFn = lpNext;
    }
  return lpRet;
}

void GetDirectoryOfFileName(LPSTR lpDest,LPSTR lpFn)
{
UINT uiLen = (UINT)(GetNameWithoutPath(lpFn) - lpFn);
  hmemcpy(lpDest,lpFn,uiLen);
  if (uiLen > 3)
  {
      LPSTR lpEnd = GetLatestChar(lpDest);
      if (lpEnd!=NULL)
          if ((*lpEnd)=='\\')
              uiLen--;
  }
  *(lpDest+uiLen)='\0';
}

WORD main(int argc,char *argv[])
{
    LONG lVersion=0;
    LPSTR lpFn=NULL;//((LPSTR)QTFILENAME);
    LPSTR lpFmtStd=((LPSTR)FMTSTD);
    HPALETTE hPal=NULL;
    LONG lQuality=0;
    BOOL fRes=TRUE;
    HANDLE hFind=NULL;
    WIN32_FIND_DATA Win32_Find_Data;
    printf("TiffConv 0.05 - (c) Copyright 1999 Gilles Vollant (info@winimage.com)\n");

    if (argc<=1)    
    {
        printf(
         "Usage :\n" \
         "     QTConv pathname_of_pic DESTINATION_FORMAT [Quality]\n\n"
         "Example :\n" \
         "     QTConv c:\\image\\*.TIF BMP\n" \
         "     QTConv c:\\image\\*.BMP TIF\n" \
         "     QTConv c:\\image\\*.BMP TIF 50\n" \
         "        (This will use a quality of 50 for the Tif)\n" \
         "\n"\
         "Destination format possible : BMP, JPG, PNG, TIF, PCX, GIF\n" \
         "  For TIF, Quality select the Compression scheme :\n" \
         "   COMPRESSION_NONE            1\n" \
         "   COMPRESSION_CCITTRLE        2\n" \
         "   COMPRESSION_CCITTFAX3       3\n" \
         "   COMPRESSION_CCITTFAX4       4\n" \
         "   COMPRESSION_LZW             5\n" \
         "   COMPRESSION_OJPEG           6\n" \
         "   COMPRESSION_JPEG            7\n" \
         "   COMPRESSION_LZW             50 without predictor\n" \
         "");
        return 0;
    }

    if (argc>1)
        lpFn=argv[1];
    if (argc>2)
        lpFmtStd=argv[2];
    if (argc>3)
        lQuality=atol(argv[3]);

    hFind=FindFirstFile(lpFn,&Win32_Find_Data);
    if (hFind!=INVALID_HANDLE_VALUE)
    {
        do
        {

            char szFullFileName[MAX_PATH+256];
            BOOL fThisRet;
            lstrcpy(szFullFileName,lpFn);
            lstrcpy((LPSTR)GetNameWithoutPath(szFullFileName),Win32_Find_Data.cFileName);
            fThisRet=DoConvertOnePicture(szFullFileName,lpFmtStd,lQuality,TRUE);    
        } while (FindNextFile(hFind,&Win32_Find_Data));
        FindClose(hFind);

    }
    return 0;
}
