#include <windows.h>
#include <windowsx.h>


#ifdef __FREEBITMAP__
#include "dibtools.h"

#include "FbDecCls.h"
#include "xgofbdec.h"

#define __BMP__


#ifdef __LIBTIFF__
LPXGOFREEBITMAPDECODER GetTiffDecoder();
#endif

#ifdef __PNG__
LPXGOFREEBITMAPDECODER GetPngDecoder();
#endif

#ifdef __JPG__
LPXGOFREEBITMAPDECODER GetJpegDecoder();
#endif

#ifdef __BMP__
LPXGOFREEBITMAPDECODER GetBmpDecoder();
#endif

#ifdef __GIF__
LPXGOFREEBITMAPDECODER GetGifDecoder();
#endif

#ifdef __PCX__
LPXGOFREEBITMAPDECODER GetPcxDecoder();
#endif

#ifdef __TGA__
LPXGOFREEBITMAPDECODER GetTgaDecoder();
#endif



static BOOL Tool_GetFileSize(LPCSTR lpFn,DWORD &dwSize,LPSTR lpTrueName)
{
WIN32_FIND_DATA ffblk;
HANDLE hFind;
char szName[MAX_PATH+1];


  lstrcpy(szName,lpFn);
  dwSize = 0;

  if ((hFind = FindFirstFile(szName,&ffblk)) == INVALID_HANDLE_VALUE)
           return FALSE;
       else
         {
           dwSize = ffblk.nFileSizeLow;
           if (lpTrueName!=NULL)
             lstrcpy(lpTrueName,ffblk.cFileName);
         }
  FindClose(hFind);

  return TRUE;
}


///////////////////////////////////////////////////////////////////////
///////////////

DWORD FillDecoderArray(LPXGOFREEBITMAPDECODER *lpDecoder)
{
    DWORD dwNbDecoderFound=0;

        #ifdef __LIBTIFF__
        lpDecoder[dwNbDecoderFound] = GetTiffDecoder();
        if (lpDecoder[dwNbDecoderFound]!=NULL)
            dwNbDecoderFound++;
        #endif

        #ifdef __PNG__
        lpDecoder[dwNbDecoderFound] = GetPngDecoder();
        if (lpDecoder[dwNbDecoderFound]!=NULL)
            dwNbDecoderFound++;
        #endif

        #ifdef __JPG__
        lpDecoder[dwNbDecoderFound] = GetJpegDecoder();
        if (lpDecoder[dwNbDecoderFound]!=NULL)
            dwNbDecoderFound++;
        #endif

        #ifdef __BMP__
        lpDecoder[dwNbDecoderFound] = GetBmpDecoder();
        if (lpDecoder[dwNbDecoderFound]!=NULL)
            dwNbDecoderFound++;
        #endif

        #ifdef __GIF__
        lpDecoder[dwNbDecoderFound] = GetGifDecoder();
        if (lpDecoder[dwNbDecoderFound]!=NULL)
            dwNbDecoderFound++;
        #endif

        #ifdef __PCX__
        lpDecoder[dwNbDecoderFound] = GetPcxDecoder();
        if (lpDecoder[dwNbDecoderFound]!=NULL)
            dwNbDecoderFound++;
        #endif

        #ifdef __TGA__
        lpDecoder[dwNbDecoderFound] = GetTgaDecoder();
        if (lpDecoder[dwNbDecoderFound]!=NULL)
            dwNbDecoderFound++;
        #endif

        return dwNbDecoderFound;
}

#define MAXDECODER (0x20)

LPXGOFREEBITMAPDECODER FREEBITMAPAPI 
                    FindDecoderForFileInMemory(LPCVOID lpData,DWORD dwSize)
{
     LPXGOFREEBITMAPDECODER lpDecoder[MAXDECODER];
     LPXGOFREEBITMAPDECODER lpRet=NULL;
     DWORD dwNbDecoder=0;
     DWORD i;

     dwNbDecoder=FillDecoderArray(lpDecoder);
     for (i=0;i<dwNbDecoder;i++)
     {
         if (lpRet==NULL)
             if (lpDecoder[i]->GetFileTypeWithBeginning(lpData,dwSize))
                 lpRet=lpDecoder[i];

         if (lpRet!=lpDecoder[i])
             delete(lpDecoder[i]);
     }
     return lpRet;
}

BOOL    FREEBITMAPAPI DeleteDecoder(LPXGOFREEBITMAPDECODER lpFBmpDec)
{
    BOOL fRet = (lpFBmpDec!=NULL);
    if (lpFBmpDec!=NULL)
        delete lpFBmpDec;
    return fRet;
}


FREEBITMAPAPIEXPORT DWORD FREEBITMAPAPI GetSupportedExt(LPSTR lpBuffer,
                                                        DWORD dwSize)
{
    char szExtList[MAXDECODER*16*2] ="";
    DWORD dwNbList=0;
    DWORD dwRet;

     LPXGOFREEBITMAPDECODER lpDecoder[MAXDECODER];
     LPXGOFREEBITMAPDECODER lpRet=NULL;
     DWORD dwNbDecoder=0;
     DWORD i;

     dwNbDecoder=FillDecoderArray(lpDecoder);
     for (i=0;i<dwNbDecoder;i++)
     {
         DWORD j;
         DWORD dwNbExt = lpDecoder[i]->GetNumberSupportedExtension();
         for (j=0;j<dwNbExt;j++)
         {
             lstrcat(szExtList,lpDecoder[i]->GetSupportedExtension(j));
             lstrcat(szExtList,";");
             dwNbList++;
         }
         delete(lpDecoder[i]);
     }

    if (lpBuffer==NULL)
        dwRet = dwNbList;
    else
    {
        DWORD dwLen = lstrlen(szExtList);
        if (dwSize>dwLen)
        {
            if (dwLen>0) 
                dwLen--; // remove the last ';'
            memcpy(lpBuffer,szExtList,dwLen);
            *(lpBuffer+dwLen)='\0';
            dwRet = dwNbList;
        }
        else
            dwRet = 0;
    }
    return dwRet;
}

FREEBITMAPAPIEXPORT BOOL FREEBITMAPAPI DecodeFromFile  (LPCSTR lpFileName, 
                                         LPRECT lpBound,HANDLE* phDib,
                                         RGBQUAD* pBmiColor,LPDWORD lpdwSize)
{
  HANDLE hFileOrg=NULL;
  HANDLE hFileMapOrg=NULL;
  LPBYTE lpFileOrg=NULL;
  DWORD dwSizeOrg=0;
  BOOL fRet=FALSE;

  if (phDib!=NULL)
      *phDib=NULL;
  if (lpdwSize!=NULL)
      *lpdwSize=0;
  if (lpBound!=NULL)
      SetRect(lpBound,0,0,0,0);

  Tool_GetFileSize(lpFileName,dwSizeOrg,NULL);

  if (dwSizeOrg>0)
  {
      hFileOrg = CreateFile(lpFileName, GENERIC_READ, FILE_SHARE_READ, NULL,
						OPEN_EXISTING, FILE_FLAG_RANDOM_ACCESS, NULL);
      if (hFileOrg != NULL)
      {
          hFileMapOrg = CreateFileMapping(hFileOrg, NULL, PAGE_READONLY, 0, 0, NULL);
          if (hFileMapOrg!=NULL)
          {
              lpFileOrg = (LPBYTE)MapViewOfFile(hFileMapOrg, FILE_MAP_READ, 0, 0, 0);
              if (lpFileOrg!=NULL)
              {
                  LPXGOFREEBITMAPDECODER lpFbDec ;
                  lpFbDec = FindDecoderForFileInMemory(lpFileOrg,dwSizeOrg);
                  if (lpFbDec != NULL)
                  {
                    fRet = lpFbDec->DecodeFromMemory(lpFileOrg,dwSizeOrg,
                                    lpBound,phDib,pBmiColor,lpdwSize);
                    DeleteDecoder(lpFbDec);
                  }
                  UnmapViewOfFile(lpFileOrg);
              }
              CloseHandle(hFileMapOrg);
          }
          CloseHandle(hFileOrg);
      }
  }
  return fRet;
}

FREEBITMAPAPIEXPORT BOOL FREEBITMAPAPI DecodeFromMemory  (LPCVOID lpData, DWORD dwSize,
                                         LPRECT lpBound,HANDLE* phDib,
                                         RGBQUAD* pBmiColor,LPDWORD lpdwSize)
{
    BOOL fRet = FALSE;
    LPXGOFREEBITMAPDECODER lpFbDec ;
    lpFbDec = FindDecoderForFileInMemory(lpData, dwSize);
    if (lpFbDec != NULL)
    {
        fRet = lpFbDec->DecodeFromMemory(lpData, dwSize,
                        lpBound,phDib,pBmiColor,lpdwSize);
        DeleteDecoder(lpFbDec);
    }
    return fRet;
}

FREEBITMAPAPIEXPORT HGLOBAL FREEBITMAPAPI LoadInDIBFromFile(
                                LPSTR lpFileName)
{
    HGLOBAL hRet = NULL;
    BOOL fResult = DecodeFromFile(lpFileName, NULL,&hRet,NULL,NULL);
    return hRet;
}

FREEBITMAPAPIEXPORT HGLOBAL FREEBITMAPAPI LoadInDIBFromMemory(
                                LPCVOID lpData, DWORD dwSize) 
{
    HGLOBAL hRet = NULL;
    BOOL fResult = DecodeFromMemory(lpData, dwSize,NULL,&hRet,NULL,NULL);
    return hRet;
}

FREEBITMAPAPIEXPORT BOOL    FREEBITMAPAPI GetBitmapFileInformationFromFile(
                                LPCSTR szFileName, LPRECT lpRect,
                                RGBQUAD* pBmiColor,LPDWORD lpdwSize)
{
    BOOL fRet = NULL;
    fRet = DecodeFromFile(szFileName, lpRect, NULL, pBmiColor, lpdwSize);
    return fRet;
}

FREEBITMAPAPIEXPORT BOOL    FREEBITMAPAPI GetBitmapFileInformationFromMemory(
                                LPCVOID lpData, DWORD dwSize,
                                LPCSTR szFileName, LPRECT lpRect,
                                RGBQUAD* pBmiColor,LPDWORD lpdwSize)
{
    BOOL fRet = NULL;
    fRet = DecodeFromMemory(lpData, dwSize, lpRect, NULL, pBmiColor, lpdwSize);
    return fRet;
}

///////////////////////////////////////////////////////////////////////

#endif
