#include <windows.h>
#include <windowsx.h>

#include "FbDecCls.h"
#include "xgofbdec.h"
#include "dibtools.h"


/********/

/**************/
#define __BMP__

#ifdef __FREEBITMAP__
#ifdef __BMP__


class XGOFREEBITMAPDECODERBMP : public XGOFREEBITMAPDECODER
  {
    public :
        XGOFREEBITMAPDECODERBMP() ;
        virtual ~XGOFREEBITMAPDECODERBMP() ;
        virtual BOOL    GetFileTypeWithBeginning(LPCVOID lpData,DWORD dwSizeSeq);
        virtual BOOL    DecodeFromMemory(LPCVOID lpData,DWORD dwSize,
                                         LPRECT lpBound,HANDLE* phDib,
                                         RGBQUAD* pBmiColor,LPDWORD lpdwSize) ;
        virtual DWORD   GetNumberSupportedExtension() ;
        virtual LPCSTR  GetSupportedExtension(DWORD dwNumber) ;
  } ;

BOOL DecodeBMP(LPCVOID lpData,DWORD dwSize, LPRECT lpBound,HANDLE* phDib,
               RGBQUAD* pBmiColor,LPDWORD lpdwSize);

XGOFREEBITMAPDECODERBMP::XGOFREEBITMAPDECODERBMP()
{
}

XGOFREEBITMAPDECODERBMP::~XGOFREEBITMAPDECODERBMP()
{
}


DWORD   XGOFREEBITMAPDECODERBMP::GetNumberSupportedExtension()
{
    return 2 ;
}

LPCSTR  XGOFREEBITMAPDECODERBMP::GetSupportedExtension(DWORD dwNumber)
{
    if (dwNumber==1)
        return "*.DIB";
    else
        return "*.BMP";
}


BOOL XGOFREEBITMAPDECODERBMP::DecodeFromMemory(LPCVOID lpData,DWORD dwSize,
                                         LPRECT lpBound,HANDLE* phDib,
                                         RGBQUAD* pBmiColor,LPDWORD lpdwSize) 
{
    return DecodeBMP(lpData,dwSize,
                     lpBound,phDib,
                     pBmiColor,lpdwSize) ;
}

BOOL XGOFREEBITMAPDECODERBMP::GetFileTypeWithBeginning(LPCVOID lpData,DWORD dwSizeSeq)
{
    BOOL fRet = FALSE;
    LPCSTR lpsz = (LPCSTR)lpData;
    if (dwSizeSeq>=4)
    {
        if ((*(lpsz) == 'B') && (*(lpsz+1) == 'M'))
            fRet=TRUE;
    }
    return fRet;
}

LPXGOFREEBITMAPDECODER GetBmpDecoder()
{
  return new XGOFREEBITMAPDECODERBMP;
}

#else  // __BMP__
LPXGOFREEBITMAPDECODER GetBmpDecoder()
{
  return NULL;
}
#endif // __BMP__
#endif // __FREEBITMAP__
///////////////////

BOOL DecodeBMP(LPCVOID lpData,DWORD dwSize, LPRECT lpBound,HANDLE* phDib,
               RGBQUAD* pBmiColor,LPDWORD lpdwSizePalette)

{
    BOOL fIsOk=TRUE;
    LPBITMAPINFO lpbmi = NULL;
    LPBYTE rawdata=NULL;
    LPBITMAPFILEHEADER lpbmfh=NULL;
    LPBITMAPINFO lpbmiOrg=NULL;


    if (phDib != NULL)
          *phDib = NULL;

    if (lpdwSizePalette!=NULL)
          *lpdwSizePalette=0;

    if (dwSize< sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFO))
        return FALSE;
    try
    {
        lpbmfh=(LPBITMAPFILEHEADER)lpData;
        lpbmiOrg = LPBITMAPINFO(lpbmfh+1);
        if (lpBound!=NULL)
            SetRect(lpBound,0,0,
                    lpbmiOrg->bmiHeader.biWidth,lpbmiOrg->bmiHeader.biHeight);
        
        {
			DWORD dwSizePal=DibTool_PaletteSize((LPSTR)lpbmiOrg);
            if (pBmiColor!=NULL)
                memcpy(pBmiColor,&(lpbmiOrg->bmiColors[0]),dwSizePal);
            if (lpdwSizePalette!=NULL)
                *lpdwSizePalette=dwSizePal;
        }

        if (phDib!=NULL)
        {
            DWORD dwSizeDib = dwSize-sizeof(BITMAPFILEHEADER);
            *phDib = GlobalAlloc(GHND,dwSizeDib);
            lpbmi=(LPBITMAPINFO)GlobalLock(*phDib);
            if (lpbmi!=NULL)
            {
                memcpy(lpbmi,lpbmiOrg,dwSizeDib);
                DWORD dwPosBit = lpbmfh->bfOffBits - sizeof(BITMAPFILEHEADER);
                DWORD dwPosBitNeeded = DibTool_FindDIBBits(lpbmiOrg)-((LPSTR)lpbmiOrg);
                if (dwPosBit<dwPosBitNeeded)
                {
                    LPBITMAPINFO lpbminew=NULL;
                    DWORD dwSize = GlobalSize(GlobalPtrHandle(lpbmi));
                    DWORD dwExpand = dwPosBitNeeded - dwPosBit;
                    if (dwSize>dwPosBit)
                        lpbminew = (LPBITMAPINFO)GlobalReAllocPtr(lpbmi,dwSize+dwExpand,GMEM_MOVEABLE);
                    if (lpbminew!=NULL)
                    {
                        memmove(((LPBYTE)lpbminew)+dwPosBitNeeded,((LPBYTE)lpbminew)+dwPosBit,dwSize-dwPosBit);
                        memset(((LPBYTE)lpbminew)+dwPosBit,0,dwExpand);
                        if (lpbminew->bmiHeader.biBitCount<=8)
                            lpbminew->bmiHeader.biClrUsed=0;
                    }
                }

                *phDib = GlobalPtrHandle(lpbmi);
                GlobalUnlock(*phDib);
            }
            else fIsOk=FALSE;
        }
	}
	catch (BOOL)
	{
	}
    return fIsOk;
}
