
#include <windows.h>
#include <windowsx.h>

#include "FbDecCls.h"
#include "xgofbdec.h"

#ifdef __FREEBITMAP__
#ifdef __LIBTIFF__

HGLOBAL LoadTIFFinDIB(LPSTR lpFileName) ;
HGLOBAL LoadTIFFinDIBFromMemory(LPCVOID lpData, DWORD dwSize);

BOOL GetBitmapFileInformationTif(LPSTR szFileName, LPRECT lpRect, RGBQUAD* pBmiColor,LPDWORD lpdwSize);
BOOL GetBitmapFileInformationFromMemoryTif(LPCVOID lpData, DWORD dwSize, 
                                           LPRECT lpRect, RGBQUAD* pBmiColor,LPDWORD lpdwSize);
void InitMyWin32WarningHandlerTif();

class XGOFREEBITMAPDECODERTIF : public XGOFREEBITMAPDECODER
  {
    public :
        XGOFREEBITMAPDECODERTIF() ;
        virtual ~XGOFREEBITMAPDECODERTIF() ;
        virtual BOOL    GetFileTypeWithBeginning(LPCVOID lpData,DWORD dwSizeSeq);

        virtual BOOL    DecodeFromMemory(LPCVOID lpData,DWORD dwSize,
                                         LPRECT lpBound,HANDLE* phDib,
                                         RGBQUAD* pBmiColor,LPDWORD lpdwSize) ;
        virtual DWORD   GetNumberSupportedExtension() ;
        virtual LPCSTR  GetSupportedExtension(DWORD dwNumber) ;
  } ;

LPXGOFREEBITMAPDECODER GetTiffDecoder()
{
  return new XGOFREEBITMAPDECODERTIF;
}

DWORD   XGOFREEBITMAPDECODERTIF::GetNumberSupportedExtension()
{
    return 2 ;
}

LPCSTR  XGOFREEBITMAPDECODERTIF::GetSupportedExtension(DWORD dwNumber)
{
    if (dwNumber==1)
        return "*.TIFF";
    else
        return "*.TIF";
}

XGOFREEBITMAPDECODERTIF::XGOFREEBITMAPDECODERTIF()
{
    InitMyWin32WarningHandlerTif();
}

XGOFREEBITMAPDECODERTIF::~XGOFREEBITMAPDECODERTIF()
{
}

BOOL DecodeTif(LPCVOID lpData,DWORD dwSize, LPRECT lpBound,HANDLE* phDib,
               RGBQUAD* pBmiColor,LPDWORD lpdwSize)
{
    BOOL fRet = TRUE;
    if ((pBmiColor!=NULL) || (lpBound!=NULL) || (phDib!=NULL))
        fRet = GetBitmapFileInformationFromMemoryTif(lpData,dwSize,
                                                lpBound,pBmiColor,lpdwSize);
    if (phDib!=NULL)
    {
        *phDib = LoadTIFFinDIBFromMemory(lpData,dwSize);
        fRet = fRet && ((*phDib)!=NULL);
    }
    return fRet;
}

BOOL XGOFREEBITMAPDECODERTIF::DecodeFromMemory(LPCVOID lpData,DWORD dwSize,
                                                LPRECT lpBound,HANDLE* phDib,
                                                RGBQUAD* pBmiColor,LPDWORD lpdwSize)
{
    return DecodeTif(lpData,dwSize,
                     lpBound,phDib,
                     pBmiColor,lpdwSize) ;
}

BOOL XGOFREEBITMAPDECODERTIF::GetFileTypeWithBeginning(LPCVOID lpData,DWORD dwSizeSeq)
{
    BOOL fRet = FALSE;
    LPCSTR lpsz = (LPCSTR)lpData;
    if (dwSizeSeq>=4)
    {
        if ((*(lpsz)=='I') && (*(lpsz+1)=='I') && (*(lpsz+2)=='*') && (*(lpsz+3)=='\0'))
            fRet=TRUE;
        if ((*(lpsz)=='M') && (*(lpsz+1)=='M') && (*(lpsz+2)=='\0') && (*(lpsz+3)=='*'))
            fRet=TRUE;
    }
    return fRet;
}

#else  // __LIBTIFF__
LPXGOFREEBITMAPDECODER GetTiffDecoder()
{
  return NULL;
}
#endif // __LIBTIFF__
#endif // __FREEBITMAP__
